> This page is for Afterpay.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.cash.app/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.cash.app/_mcp/server.

# Capture Full Recurring Payment

POST https://global-api-sandbox.afterpay.com/v2/recurring-payments
Content-Type: application/json

Creates and immediately captures a recurring payment using a billing agreement token.
This endpoint combines authorization and capture into a single step.

*Deprecated. For new integrations, see [Grants](https://afterpay.docs.buildwithfern.com/afterpay-online-developer/api-reference/reference/grants/start-grant-approval).*

Reference: https://developers.cash.app/afterpay/api-reference/reference/billing-agreements-deprecated/capture-full-recurring-payment

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Servers

- `https://global-api-sandbox.afterpay.com` (Sandbox, default)
- `https://global-api.afterpay.com` (Production)

## Request

### Headers

- `Accept` ("application/json", required)

### Body (application/json)

This endpoint expects a RecurringPaymentRequest.

- `requestId` (string, required) — A unique identifier for the request, used for idempotency
- `paymentMethod` (RecurringPaymentRequestPaymentMethod, required)
- `amount` (Money, required) — The total amount of the payment
- `consumer` (Consumer, optional) — The consumer data model is used for gathering essential user information. It captures details such as the individual's first name, represented by `givenNames`, and their last name, captured under `surname`. In addition, it stores the user's contact number under `phoneNumber` and their email address under `email`. These fields collectively provide contact and identification details for a user.
- `billing` (Contact, optional) — This data model is used for storing an individual's contact information. Mandatory fields such as **name**, **line1**, **area1**, **region**, **postcode**, and **countryCode** help in capturing vital information about a user's location. The `line2` and `area2` fields provide additional space for extended addresses, while `phoneNumber` can be used to store the user's contact number. The `area1`, `area2` and `region` properties feature localized terminology based on country. Refer to the property descriptions for insights on each country's specific usage
- `shipping` (Contact, optional) — This data model is used for storing an individual's contact information. Mandatory fields such as **name**, **line1**, **area1**, **region**, **postcode**, and **countryCode** help in capturing vital information about a user's location. The `line2` and `area2` fields provide additional space for extended addresses, while `phoneNumber` can be used to store the user's contact number. The `area1`, `area2` and `region` properties feature localized terminology based on country. Refer to the property descriptions for insights on each country's specific usage
- `courier` (ShippingCourier, optional) — Essential information for tracking a shipment. The `shippedAt` key represents the date and time when the item was shipped. This value follows the [ISO 8601 standard format](https://www.iso.org/iso-8601-date-and-time-format.html) for date and time representations. The `name` field indicates the courier service employed to handle the shipment (e.g. FEDEX, UPS). For orders that are picked up in-store (also known as Buy-Online-Pickup-Instore), please use "INSTORE_PICKUP" as the `name` field value. The `tracking` key represents a unique tracking number provided by the courier service to monitor the shipment's progress. It's a valuable tool for customers and businesses to track and trace their packages. The `priority` field tracks the shipping speed or service level associated with the delivery.
- `items` (list of Item, optional)
- `discounts` (list of Discount, optional)
- `description` (string, optional)
- `merchant` (RecurringPaymentRequestMerchant, optional)
- `merchantReference` (string, optional) — The reference/order ID in the merchant's system
- `shippingAmount` (Money, optional) — The shipping cost amount
- `taxAmount` (Money, optional) — The tax amount
- `custom` (map from string to any, optional) — Custom key-value pairs for merchant use
- `paymentScheduleChecksum` (string, optional) — Payment schedule validation checksum
- `enrichments` (RecurringPaymentRequestEnrichments, optional)

## Response

### 201

| Status | Description | | ----- | ----- | | `APPROVED` | If payment is approved by Afterpay, returns a Payment object in response, with a status of "APPROVED". | | `DECLINED` | If payment is declined by Afterpay, for example, if expired payment method, returns a Payment object in response, with a status of "DECLINED". Please advise the consumer to contact the Afterpay Customer Service team for more information. |

- `id` (string, optional) — The unique, permanent, Afterpay generated Order ID.
- `token` (string, optional) — The token obtained from the checkout call
- `status` (enum, optional) — represents the status of the order
  - Allowed values: `APPROVED`, `DECLINED`
- `created` (string, optional) — is the UTC timestamp of when the payment was completed.
- `originalAmount` (Money, optional) — Object containing amount and currency
- `openToCaptureAmount` (Money, optional) — Object containing amount and currency
- `paymentState` (enum, optional) — is the current state for capturing payments
  - Allowed values: `AUTH_APPROVED`, `AUTH_DECLINED`, `PARTIALLY_CAPTURED`, `CAPTURED`, `CAPTURE_DECLINED`, `VOIDED`
- `merchantReference` (string, optional) — is the merchant's order id/reference that the payment corresponds to.
- `refunds` (list of Refund, optional)
- `orderDetails` (OrderDetails, optional) — This comprehensive schema is designed to store an entire transaction's detail, covering crucial aspects like consumer information, billing and shipping details, courier particulars, item list, discounts, tax, and shipping amount.
- `events` (list of PaymentEvent, optional)

## Errors

### 402 Capture Full Recurring Payment Request Payment Required Error

If payment is declined by Afterpay, for example, if invalid card details were entered, returns a Payment object in response, with a `status` of "DECLINED" and a `paymentState` of "AUTH_DECLINED". Please advise the consumer to contact the Afterpay Customer Service team for more information. As well, the following errorCodes are possible: | errorCode | Description | | --- | --- | | invalid_token | The checkout token is invalid, expired, or does not exist.

- `any`

### 415 Capture Full Recurring Payment Request Unsupported Media Type Error

Unsupported Media Type

- `any`

### 422 Capture Full Recurring Payment Request Unprocessable Entity Error

| errorCode | Description | | --- | --- | | invalid_object | One or more required fields were missing or invalid. | | unsupported_payment_type | The amount is outside of the merchant's payment limits, as returned by Get Configuration. | | unsupported_currency | The amount is outside of the merchant's payment limits, as returned by Get Configuration. |

- `any`

## Types

### RecurringPaymentRequestPaymentMethod

- `token` (string, required) — The billing agreement token
- `type` ("BILLING_AGREEMENT", required) — The payment method type

### Money

Object containing amount and currency

- `amount` (string, required) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (enum, required)
  - Allowed values: `AUD`, `NZD`, `USD`, `CAD`, `GBP`

### Consumer

The consumer data model is used for gathering essential user information. It captures details such as the individual's first name, represented by `givenNames`, and their last name, captured under `surname`. In addition, it stores the user's contact number under `phoneNumber` and their email address under `email`. These fields collectively provide contact and identification details for a user.

- `email` (string, required)
- `givenNames` (string, optional) — The consumer's first name
- `surname` (string, optional) — The consumer's last name
- `phoneNumber` (string, optional)

### Contact

This data model is used for storing an individual's contact information. Mandatory fields such as **name**, **line1**, **area1**, **region**, **postcode**, and **countryCode** help in capturing vital information about a user's location. The `line2` and `area2` fields provide additional space for extended addresses, while `phoneNumber` can be used to store the user's contact number. The `area1`, `area2` and `region` properties feature localized terminology based on country. Refer to the property descriptions for insights on each country's specific usage

- `name` (string, required)
- `line1` (string, required) — First line of the address
- `area1` (string, required) — - AU: Suburb - NZ: Town or City - UK: Postal Town - US: City - Canada: City
- `region` (string, required) — - AU: State - NZ: Region - UK: County - US: State - CA: Province or Territory
- `postcode` (string, required)
- `countryCode` (enum, required)
  - Allowed values: `AU`, `NZ`, `US`, `CA`, `GB`
- `line2` (string, optional) — Second line of the address
- `area2` (string, optional) — - NZ: suburb - UK: village or local area.
- `phoneNumber` (string, optional) — The phone number, in [E.123](https://en.wikipedia.org/wiki/E.123) format.

### ShippingCourier

Essential information for tracking a shipment. The `shippedAt` key represents the date and time when the item was shipped. This value follows the [ISO 8601 standard format](https://www.iso.org/iso-8601-date-and-time-format.html) for date and time representations. The `name` field indicates the courier service employed to handle the shipment (e.g. FEDEX, UPS). For orders that are picked up in-store (also known as Buy-Online-Pickup-Instore), please use "INSTORE_PICKUP" as the `name` field value. The `tracking` key represents a unique tracking number provided by the courier service to monitor the shipment's progress. It's a valuable tool for customers and businesses to track and trace their packages. The `priority` field tracks the shipping speed or service level associated with the delivery.

- `shippedAt` (datetime, optional)
- `name` (string, optional)
- `tracking` (string, optional)
- `priority` (enum, optional)
  - Allowed values: `STANDARD`, `EXPRESS`

### Item

This data model is used to store crucial product details. The `price.amount` field represents the unit price of the individual item. The `quantity` field shows the number of units of the item. The `name` field denotes the name of the product, while `sku` holds the Stock Keeping Unit identifier. 100 is the maximum number of item objects in the items array. It is crucial that the `price.amount` represents the unit price of the individual item. **Never** populate the `price.amount` by multiplying the quantity by the unit cost. Always enter the price for a single unit to maintain data accuracy.

- `name` (string, required)
- `quantity` (integer, required)
- `price` (Money, required) — Object containing amount and currency
- `sku` (string, optional)
- `pageUrl` (string, optional)
- `imageUrl` (string, optional)
- `categories` (list of list of string, optional)
- `estimatedShipmentDate` (string, optional)
- `preorder` (boolean, optional, default: false)

### Discount

Discount applied to an order

- `displayName` (string, optional)
- `amount` (Money, optional) — Object containing amount and currency

### RecurringPaymentRequestMerchant

- `name` (string, optional) — The merchant name to display

### RecurringPaymentRequestEnrichments

- `initiation` (RecurringPaymentRequestEnrichmentsInitiation, optional) — Describes who initiated the transaction

### Refund

To guarantee safe retries, the merchant should offer their refund ID or reference, aligning with their internal records Unique values for the `requestID` and `merchantReference` are required to guarantee safe retries. It is recommended that the merchant generates a UUID for each unique refund request. The `refundMerchantReference` is a unique reference that when provided, will appear in the daily settlement file as "Payment Event Id". In most cases, this would hold the same value as the `merchantReference`.

- `amount` (Money, optional) — Object containing amount and currency
- `merchantReference` (string, optional) — The merchant’s internal refund id/reference. This must be included along with the `requestId` to utilise idempotency. Max length 85 (varchar).
- `refundId` (string, optional) — The unique, permanent, Afterpay-generated Refund ID.
- `refundMerchantReference` (string, optional) — A unique reference for the individual refund event. Max length 128 (varchar).
- `refundedAt` (string, optional)
- `requestId` (string, optional) — Unique ID required for safe retries. Max length 64 (varchar).

### OrderDetails

This comprehensive schema is designed to store an entire transaction's detail, covering crucial aspects like consumer information, billing and shipping details, courier particulars, item list, discounts, tax, and shipping amount.

- `consumer` (Consumer, optional) — The consumer data model is used for gathering essential user information. It captures details such as the individual's first name, represented by `givenNames`, and their last name, captured under `surname`. In addition, it stores the user's contact number under `phoneNumber` and their email address under `email`. These fields collectively provide contact and identification details for a user.
- `billing` (Contact, optional) — This data model is used for storing an individual's contact information. Mandatory fields such as **name**, **line1**, **area1**, **region**, **postcode**, and **countryCode** help in capturing vital information about a user's location. The `line2` and `area2` fields provide additional space for extended addresses, while `phoneNumber` can be used to store the user's contact number. The `area1`, `area2` and `region` properties feature localized terminology based on country. Refer to the property descriptions for insights on each country's specific usage
- `courier` (ShippingCourier, optional) — Essential information for tracking a shipment. The `shippedAt` key represents the date and time when the item was shipped. This value follows the [ISO 8601 standard format](https://www.iso.org/iso-8601-date-and-time-format.html) for date and time representations. The `name` field indicates the courier service employed to handle the shipment (e.g. FEDEX, UPS). For orders that are picked up in-store (also known as Buy-Online-Pickup-Instore), please use "INSTORE_PICKUP" as the `name` field value. The `tracking` key represents a unique tracking number provided by the courier service to monitor the shipment's progress. It's a valuable tool for customers and businesses to track and trace their packages. The `priority` field tracks the shipping speed or service level associated with the delivery.
- `items` (list of Item, optional)
- `discounts` (list of Discount, optional)
- `taxAmount` (Money, optional) — Object containing amount and currency
- `shippingAmount` (Money, optional) — Object containing amount and currency

### PaymentEvent

Each payment event has a unique ID, creation timestamp, and type (e.g., "AUTH_APPROVED", "AUTH_DECLINED"). For "AUTH_APPROVED" events, an expiration timestamp is provided. The "payment event merchant reference" field, which can be used for payment capture events

- `id` (string, optional)
- `created` (string, optional)
- `expires` (string, optional)
- `type` (enum, optional)
  - Allowed values: `AUTH_APPROVED`, `AUTH_DECLINED`, `CAPTURED`, `CAPTURE_DECLINED`, `VOIDED`, `EXPIRED`
- `amount` (Money, optional) — Object containing amount and currency
- `paymentEventMerchantReference` (string, optional)

### RecurringPaymentRequestEnrichmentsInitiation

Describes who initiated the transaction

- `actor` (enum, optional) — The actor initiating the transaction. Use MERCHANT when the customer is not present.
  - Allowed values: `CUSTOMER`, `MERCHANT`

## Examples

**Request**

```json
{
  "requestId": "123e4567-e89b-12d3-a456-426614174000",
  "paymentMethod": {
    "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2",
    "type": "BILLING_AGREEMENT"
  },
  "amount": {
    "amount": "100.00",
    "currency": "AUD"
  }
}
```

**Response**

```json
{
  "id": "300000016189",
  "token": "002.6bjbsaowxvfqam2nw4u3xudppheuh4gsuat3n2w3f6t44euzgy",
  "status": "APPROVED",
  "created": "2024-03-11T20:11:42.487Z",
  "originalAmount": {
    "amount": "37.00",
    "currency": "USD"
  },
  "openToCaptureAmount": {
    "amount": "0.00",
    "currency": "USD"
  },
  "paymentState": "CAPTURED",
  "merchantReference": "updated-k6-reference-utaddnpx",
  "refunds": [
    {
      "amount": {
        "amount": "10.00",
        "currency": "AUD"
      },
      "merchantReference": "merchantRefundId-1234",
      "refundId": "67890123",
      "refundMerchantReference": "merchantRefundId-1234",
      "refundedAt": "2023-01-01T00:00:00.000Z",
      "requestId": "49efce77-4bf2-4e41-86e8-c2b92f493c2a"
    }
  ],
  "orderDetails": {
    "consumer": {
      "email": "test@example.com",
      "givenNames": "Joe",
      "surname": "Consumer",
      "phoneNumber": "0400 000 000"
    },
    "billing": {
      "name": "Joe Customer",
      "line1": "1004 New Avenue",
      "area1": "Melbourne",
      "region": "VIC",
      "postcode": "94121",
      "countryCode": "AU",
      "line2": "390 Collins Street",
      "area2": "area2",
      "phoneNumber": "2120000000"
    },
    "courier": {
      "shippedAt": "2024-01-01T08:00:00Z",
      "name": "FedEx",
      "tracking": "000 000 000 000",
      "priority": "STANDARD"
    },
    "items": [
      {
        "name": "Blue Carabiner",
        "quantity": 1,
        "price": {
          "amount": "40.00",
          "currency": "AUD"
        },
        "sku": "12341234",
        "pageUrl": "https://example.com/carabiner-354193.html",
        "imageUrl": "https://example.com/carabiner-7378-391453-1.jpg",
        "categories": [
          [
            "Sporting Goods",
            "Climbing Equipment",
            "Climbing",
            "Climbing Carabiners"
          ],
          [
            "Sale",
            "Climbing"
          ]
        ],
        "estimatedShipmentDate": "2023-08-01"
      }
    ],
    "discounts": [
      {
        "displayName": "New Customer Coupon",
        "amount": {
          "amount": "100.00",
          "currency": "AUD"
        }
      }
    ],
    "taxAmount": {
      "amount": "100.00",
      "currency": "AUD"
    },
    "shippingAmount": {
      "amount": "100.00",
      "currency": "AUD"
    }
  },
  "events": [
    {
      "id": "1OUR16OTqL3DgJ3ELlwKowU9v6K",
      "created": "2023-09-01T00:00:00.000Z",
      "expires": "2023-09-01T01:00:00.000Z",
      "type": "AUTH_APPROVED",
      "amount": {
        "amount": "100.00",
        "currency": "AUD"
      },
      "paymentEventMerchantReference": "paymentEventMerchantReference"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/recurring-payments"

payload = {
    "requestId": "123e4567-e89b-12d3-a456-426614174000",
    "paymentMethod": {
        "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2",
        "type": "BILLING_AGREEMENT"
    },
    "amount": {
        "amount": "100.00",
        "currency": "AUD"
    }
}
headers = {
    "Accept": "application/json"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/recurring-payments';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"requestId":"123e4567-e89b-12d3-a456-426614174000","paymentMethod":{"token":"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2","type":"BILLING_AGREEMENT"},"amount":{"amount":"100.00","currency":"AUD"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/recurring-payments"

	payload := strings.NewReader("{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"paymentMethod\": {\n    \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\",\n    \"type\": \"BILLING_AGREEMENT\"\n  },\n  \"amount\": {\n    \"amount\": \"100.00\",\n    \"currency\": \"AUD\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/recurring-payments")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"paymentMethod\": {\n    \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\",\n    \"type\": \"BILLING_AGREEMENT\"\n  },\n  \"amount\": {\n    \"amount\": \"100.00\",\n    \"currency\": \"AUD\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v2/recurring-payments")
  .header("Accept", "application/json")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"paymentMethod\": {\n    \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\",\n    \"type\": \"BILLING_AGREEMENT\"\n  },\n  \"amount\": {\n    \"amount\": \"100.00\",\n    \"currency\": \"AUD\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v2/recurring-payments', [
  'body' => '{
  "requestId": "123e4567-e89b-12d3-a456-426614174000",
  "paymentMethod": {
    "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2",
    "type": "BILLING_AGREEMENT"
  },
  "amount": {
    "amount": "100.00",
    "currency": "AUD"
  }
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/recurring-payments");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"paymentMethod\": {\n    \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\",\n    \"type\": \"BILLING_AGREEMENT\"\n  },\n  \"amount\": {\n    \"amount\": \"100.00\",\n    \"currency\": \"AUD\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "Accept": "application/json",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [
  "requestId": "123e4567-e89b-12d3-a456-426614174000",
  "paymentMethod": [
    "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2",
    "type": "BILLING_AGREEMENT"
  ],
  "amount": [
    "amount": "100.00",
    "currency": "AUD"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/recurring-payments")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```